proc ML_init {}\
{
	global CHML USER
	set ct [catch {set CHML [lindex [socket $USER(smtp_server) 25] 0]}]
	if {$ct > 0}\
	{
		myError "Cannot open a connection with $USER(smtp_server)"
		return -code return
	}
	set a [_read $CHML]
	if {[crange $a 0 2] != 220}\
	{
		#ML_error [crange $a 0 2]
		return 0
	}\
	else\
	{
		return 1
	}	
}

proc ML_helo {host}\
{
	global CHML
	_write $CHML "helo $host"
	set a [_read $CHML]
 	if {[crange $a 0 2] != 250}\
	{
		#ML_error [crange $a 0 2]
		return 0
	}\
	else\
	{
		return 1
	}
}

proc ML_mailFrom {from}\
{
	global CHML
	_write $CHML "mail from: $from"
	set a [_read $CHML]
 	if {[crange $a 0 2] != 250}\
	{
		#ML_error [crange $a 0 2]
		return 0
	}\
	else\
	{
		return 1
	}
}

proc ML_rcptTo {recipient}\
{
	global CHML
	_write $CHML "rcpt to: $recipient"
	set a [_read $CHML]
 	if {[crange $a 0 1] != 25}\
	{
		#ML_error [crange $a 0 1]
		return 0
	}\
	else\
	{
		return 1
	}
}

proc ML_data {}\
{
	global CHML
	_write $CHML "data"
	set a [_read $CHML]
 	if {[crange $a 0 2] != 354}\
	{
		#ML_error [crange $a 0 2]
		return 0
	}\
	else\
	{
		return 1
	}
}

proc ML_subject {subject}\
{
	global CHML
	_write $CHML "Subject: $subject"
}
	
proc ML_cc {cc}\
{
	global CHML
	_write $CHML "Cc: $cc"
}
	
proc ML_bcc {bcc}\
{
	global CHML
	_write $CHML "Bcc: $bcc"
}
	
proc ML_msg {msg}\
{
	global CHML
	_write $CHML "$msg"
}
	
proc ML_endData {}\
{
	global CHML
	_write $CHML "."
	set a [_read $CHML]
	if {[crange $a 0 2] != 250}\
	{
		#ML_error [crange $a 0 2]
		return 0
	}\
	else\
	{
		return 1
	}
}

proc ML_rset {}\
{
	global CHML
	_write $CHML "rset"
	set a [_read $CHML]
	if {[crange $a 0 2] != 250}\
	{
		#ML_error [crange $a 0 2]
		return 0
	}\
	else\
	{
		return 1
	}
}

proc ML_vrfy {addr}\
{
	global CHML
	_write $CHML "vrfy $addr"
	set a [_read $CHML]
	if {[crange $a 0 1] == 25}\
	{
		return 1
	}\
	else\
	{
		return 0
	}
}

proc ML_noop {}\
{
	global CHML
	_write $CHML "noop"
	set a [_read $CHML]
	if {[crange $a 0 2] != 250}\
	{
		#ML_error [crange $a 0 2]
		return 0
	}\
	else\
	{
		return 1
	}
}
	
	
proc ML_quit {}\
{
	global CHML
	_write $CHML "quit"
	set a [_read $CHML]
	if {[crange $a 0 2] != 221}\
	{
		#ML_error [crange $a 0 2]
		return 0
	}
	close $CHML
}

proc ML_error {err}\
{
	switch $err\
	{
		421 {myError "Mail service not available now. Retry later"}
		550 {myError "Mailbox not found."}
		450 {myError "Mailbox busy."}
		551 {myError "Bad user"}
		452 {myError "Insufficient system storage"}
		552 {myError "Exceeded storage allocation"}
		* {myError "Transaction failed"}	
	}
}
